/*!
 * File:
 *  radio_hal.c
 *
 * Description:
 *  This file contains RADIO HAL.
 *
 * Silicon Laboratories Confidential
 * Copyright 2011 Silicon Laboratories, Inc.
 */
#include "radio_hal.h"
#include "myRadio_gpio.h"
#include "stm32f10x_gpio.h"

void radio_hal_AssertShutdown(void)
{
  RF_SPI_PDN_H();
}

void radio_hal_DeassertShutdown(void)
{
    RF_SPI_PDN_L();
}

void radio_hal_ClearNsel(void)
{
   BOARD_SPI_NSS_L();
}

void radio_hal_SetNsel(void)
{
   BOARD_SPI_NSS_H();
}

uint8_t radio_hal_NirqLevel(void)
{
  return READ_RF_SI4438_IRQ();
  
}

void radio_hal_SpiWriteByte(uint8_t byteToWrite)
{
  SpiReadWrite(byteToWrite);
}

uint8_t radio_hal_SpiReadByte(void)
{
  return SpiReadWrite(0xFF);
}

void radio_hal_SpiWriteData(uint8_t byteCount, uint8_t* pData)
{
  SpiWriteData(pData, byteCount);
}

void radio_hal_SpiReadData(uint8_t byteCount, uint8_t* pData)
{
  SpiReadData(pData, byteCount);
}

uint8_t radio_hal_Gpio0Level(void)
{
  uint8_t retVal;
 
  retVal = Bit_SET;
  
  return retVal;
}

uint8_t radio_hal_Gpio1Level(void)
{
  uint8_t retVal;
  

  retVal = Bit_SET;
    
  return retVal;
}

uint8_t radio_hal_Gpio2Level(void)
{
  uint8_t retVal;
  
  
  retVal = Bit_SET;

  return retVal;
}

uint8_t radio_hal_Gpio3Level(void)
{
  uint8_t retVal;

  retVal = Bit_SET;
  
  return retVal;
}
